<?php

// Media of the day (background uploader)
// ````````````````

require_once(dirname(__FILE__).'/common.php');

echo S_PAGETITLE." Background Uploader\n\n";

// Retrieve file path from arguments

if (! isset($_SERVER['argv'][1]) ) {
	dieslow('Error: Not enough command-line arguments.');
}
$fname = $_SERVER['argv'][1];
$fpath = S_IMAGESTORE . $fname;
echo "File: '".$fname."'\n";
echo "Path: '".$fpath."'\n";

// Upload the image

echo "Beginning upload to imgur...\n";
$result = imgurUpload($fpath);
echo "The upload " . ($result[0] ? 'succeeded' : 'failed'). ': ' . $result[1] . "\n";

// Add the URL to the database

if ($result[0]) {
	DB\setRemoteData($fname, $result[1]);
	echo "Added to database.\n";
}

// Return

dieslow('Script completed successfully.');


// Helper functions

function dieslow($sz) {
	echo $sz;
	sleep(5);
	die();
}

function imgurUpload($filename) {
	
	// Prepare API request
	$pvars = array(
		'image' => base64_encode(@file_get_contents($filename)),
		'key' => IMGUR_API_KEY
	);
	$curl  = curl_init();
	curl_setopt($curl, CURLOPT_URL, 'http://imgur.com/api/upload.json');
	curl_setopt($curl, CURLOPT_TIMEOUT, UPLOAD_TIMEOUT);
	curl_setopt($curl, CURLOPT_POST, 1);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $pvars);

	// Make request
	$json = curl_exec($curl);
	curl_close ($curl);
	
	// Parse response
	$response = json_decode($json, true);
	if ($response === null) return array(false, 'Malformed response from server.');
	
	if ($response['rsp']['stat'] == 'ok') {
		return array(true, $response['rsp']['image']['original_image']);
	} else if ($response['rsp']['stat'] == 'fail') {
		return array(false, $response['rsp']['image']['error_msg']);
	} else {
		return array(false, 'Invalid response from server.');
	}
}