<?php

/* MOTD Gallery */

require_once(dirname(__FILE__).'/../common.php');

if (! isset($_GET['p'])) redirect('?p=0');
$count = DB\getCount();
$lastpage = intval(ceil(DB\getCount() / G_IMGPERPAGE)) - 1;
$inline = isset($_GET['inline']);

if ($_GET['p'] == 'all') {
	$p = 0;
	$start_from = 0;

} else {
	$p = intval($_GET['p']);

	if ($p > $lastpage) redirect('?p='.$lastpage);
	if ($p < 0) redirect('?p=0');

	$start_from = ($p * G_IMGPERPAGE);
	$count = G_IMGPERPAGE;
}

header('Content-Type: text/html; charset=UTF-8');

if (! $inline) {
?>
<!DOCTYPE html>
<html>
	<head>
		<title><?=hesc(S_PAGETITLE)?></title>
		<link rel="stylesheet" type="text/css" href="style.css" />
		<script type="text/javascript">
var NEXTPAGE = <?=json_encode($p + 1)?>;
		
function ajaxGet(address, onSuccess, onFailure) {	
	var r;
	if (window.XMLHttpRequest) {
		r = new XMLHttpRequest();
		if (r === null) {
			onFailure();
			return;
		}
	} else if (window.ActiveXObject) { 
		try {
			r = new ActiveXObject("Microsoft.XMLHTTP");
		} catch (ex) {
			onFailure();
			return;
		}
	} else {
		onFailure();
		return;
	}
	
	r.onreadystatechange = function() {
		if (r.readyState == 4 /*complete*/){
			if (r.status == 200 || window.location.href.indexOf("http") == -1){
				onSuccess(r.responseText);
			} else {
				onFailure();
			}
		}
	}
	
	r.open("GET", address, true);
	r.send(null);	
	return;
}

window.onload = function() {
	var moreitems = document.getElementById('moreitems');
	
	document.getElementById('loadMore').onclick = function() {
		ajaxGet(
			"?p="+NEXTPAGE+"&inline",
			function(ret) {				
				moreitems.innerHTML += ret;
				NEXTPAGE++;
			},
			function() {
				moreitems.innerHTML += "<strong>error</strong>";
			}
		);
	}
};
		</script>
	</head>
	<body>
		<div id="gallery_menu">
			&nbsp;
			<a href="index.php">Home</a>
			<a href="gallery.php?p=0" title="Newest">&laquo;</a>
			<a href="gallery.php?p=<?=$p-1?>" title="Newer">&lt;</a>
			<a href="gallery.php?p=<?=$p+1?>" title="Older">&gt;</a>
			<a href="gallery.php?p=<?=$lastpage?>" title="Oldest">&raquo;</a>
			<a href="gallery.php?p=all">All</a>
		</div>
		<div id="gallery_main">
<?php
}

foreach(DB\GetRange($start_from, $count) as $item) {
	echo formatItem($item)."<br>\n";
}

if (! $inline) { 
?> 
			<div id="moreitems"></div>
			<a id="loadMore" href="javascript:;">load more...</a><br>
			<br>
		</div>
	</body>
</html>
<?php

}